#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 43 "./ftpcmd.y"

#ifndef lint
static char sccsid[] = "@(#)ftpcmd.y	5.24 (Berkeley) 2/25/91";
#endif /* not lint */


#include <sys/types.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#ifdef HAVE_SYS_SOCKIO_H
#include <sys/sockio.h>
#endif
#include <sys/stat.h>
#include <netinet/in.h>
#include <arpa/ftp.h>
#include <signal.h>
#include <setjmp.h>
#include <syslog.h>
#include <time.h>
#include <pwd.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#include "ftpd_var.h"

extern	char *auth_type;

unsigned int maxbuf, actualbuf;
unsigned char *ucbuf;

static int kerror;	/* XXX needed for all auth types */
#ifdef KRB5_KRB4_COMPAT
extern	struct sockaddr_in his_addr, ctrl_addr;
#include <krb.h>
extern AUTH_DAT kdata;
extern Key_schedule schedule;
extern MSG_DAT msg_data;
#endif /* KRB5_KRB4_COMPAT */
#ifdef GSSAPI
#include <gssapi/gssapi.h>
#include <gssapi/gssapi_generic.h>
extern gss_ctx_id_t gcontext;
#endif

#ifndef unix
/* sigh */
#if defined(_AIX) || defined(__hpux) || defined(BSD)
#define unix
#endif
#endif

#ifndef NBBY
#define NBBY 8
#endif

static struct sockaddr_in host_port;

extern	struct sockaddr_in data_dest;
extern	int logged_in;
extern	struct passwd *pw;
extern	int guest;
extern	int logging;
extern	int type;
extern	int form;
extern	int clevel;
extern	int debug;


extern	int allow_ccc;
extern	int ccc_ok;
extern	int timeout;
extern	int maxtimeout;
extern  int pdata;
extern	int authlevel;
extern	char hostname[], remotehost[];
extern	char proctitle[];
extern	char *globerr;
extern	int usedefault;
extern  int transflag;
extern  char tmpline[];

char	**ftpglob();

off_t	restart_point;

static	int cmd_type;
static	int cmd_form;
static	int cmd_bytesz;
char	cbuf[FTP_BUFSIZ]; /* was 512 */
char	*fromname;

/* bison needs these decls up front */
extern jmp_buf errcatch;

#define	CMD	0	/* beginning of command */
#define	ARGS	1	/* expect miscellaneous arguments */
#define	STR1	2	/* expect SP followed by STRING */
#define	STR2	3	/* expect STRING */
#define	OSTR	4	/* optional SP then STRING */
#define	ZSTR1	5	/* SP then optional STRING */
#define	ZSTR2	6	/* optional STRING after SP */
#define	SITECMD	7	/* SITE command */
#define	NSTR	8	/* Number followed by a string */

struct tab {
	char	*name;
	short	token;
	short	state;
	short	implemented;	/* 1 if command is implemented */
	char	*help;
};
struct tab cmdtab[];
struct tab sitetab[];

void sizecmd(char *);
void help(struct tab *, char *);
static int yylex(void);
static char *copy(char *);
#line 167 "./ftpcmd.y"
typedef union { int num; char *str; } YYSTYPE;
#line 142 "y.tab.c"
#define YYERRCODE 256
#define SP 257
#define CRLF 258
#define COMMA 259
#define STRING 260
#define NUMBER 261
#define USER 262
#define PASS 263
#define ACCT 264
#define REIN 265
#define QUIT 266
#define PORT 267
#define PASV 268
#define TYPE 269
#define STRU 270
#define MODE 271
#define RETR 272
#define STOR 273
#define APPE 274
#define MLFL 275
#define MAIL 276
#define MSND 277
#define MSOM 278
#define MSAM 279
#define MRSQ 280
#define MRCP 281
#define ALLO 282
#define REST 283
#define RNFR 284
#define RNTO 285
#define ABOR 286
#define DELE 287
#define CWD 288
#define LIST 289
#define NLST 290
#define SITE 291
#define STAT 292
#define HELP 293
#define NOOP 294
#define MKD 295
#define RMD 296
#define PWD 297
#define CDUP 298
#define STOU 299
#define SMNT 300
#define SYST 301
#define SIZE 302
#define MDTM 303
#define AUTH 304
#define ADAT 305
#define PROT 306
#define PBSZ 307
#define CCC 308
#define UMASK 309
#define IDLE 310
#define CHMOD 311
#define LEXERR 312
const short yylhs[] = {                                        -1,
    0,    0,    0,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   14,   14,   11,    9,    9,    7,   15,    1,    1,
    1,    2,    2,    2,    2,   16,   16,   16,   16,   16,
   16,   16,   16,    3,    3,    3,    4,    4,    4,   10,
   12,    5,    6,    8,
};
const short yylen[] = {                                         2,
    0,    2,    2,    4,    4,    4,    3,    4,    2,    4,
    4,    4,    4,    4,    8,    5,    5,    5,    3,    5,
    3,    5,    5,    2,    5,    4,    2,    3,    5,    2,
    4,    2,    5,    5,    3,    3,    4,    6,    5,    7,
    9,    4,    6,    5,    2,    5,    5,    4,    4,    2,
    2,    5,    4,    1,    0,    1,    1,   11,    1,    1,
    1,    1,    1,    1,    1,    1,    3,    1,    3,    1,
    1,    3,    2,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    1,
};
const short yydefred[] = {                                      1,
    0,    0,    0,    0,    0,    0,   83,    0,    0,    0,
   83,   83,   83,    0,    0,   83,    0,    0,   83,   83,
   83,   83,    0,    0,    0,    0,   83,   83,   83,   83,
   83,    0,   83,   83,    0,    0,    0,    0,    0,    2,
    3,   51,    0,    0,   50,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   27,    0,    0,
    0,    0,    0,   24,    0,    0,   30,   32,   84,    0,
    0,    0,    0,    0,   45,    0,    0,    0,    0,    0,
    0,    9,   54,    0,   56,    0,    0,    0,    7,    0,
    0,   70,    0,    0,   75,   76,   74,    0,   79,   77,
   78,    0,    0,    0,    0,    0,   57,    0,    0,   81,
    0,   80,    0,    0,   28,    0,   21,    0,   19,    0,
   83,    0,   83,    0,    0,    0,    0,   35,   36,    0,
    0,    0,    0,    0,   62,   63,   64,   65,    0,    0,
    4,    5,    0,    6,    0,    0,    0,   73,   11,   12,
   13,    0,    0,    0,    0,   14,   53,    0,   26,    0,
    0,    0,    0,    0,   37,    0,    0,    0,   42,    0,
    0,   31,    0,    0,    0,    0,    0,   48,   49,    8,
   10,    0,   59,   60,   61,   69,   67,   72,   16,   17,
   18,    0,   52,   25,   29,   22,   20,    0,   39,    0,
    0,    0,   23,   33,   34,   44,   46,   47,    0,    0,
   38,   82,    0,   43,    0,    0,    0,   40,    0,    0,
   15,    0,    0,   41,    0,    0,    0,   58,
};
const short yydgoto[] = {                                       1,
  186,  139,   98,  102,  213,   69,  108,   70,   86,  111,
   84,  112,   40,   41,   88,   94,
};
const short yysindex[] = {                                      0,
 -141, -246, -242, -237, -216, -210,    0, -206, -200, -182,
    0,    0,    0, -181, -180,    0, -179, -178,    0,    0,
    0,    0, -176, -175, -224, -174,    0,    0,    0,    0,
    0, -173,    0,    0, -171, -170, -169, -168, -167,    0,
    0,    0, -166, -165,    0, -164, -159,  -10,  -63,  -58,
 -157, -156, -155, -158, -154, -153, -152,    0, -151, -221,
 -212, -193, -249,    0, -148, -150,    0,    0,    0, -146,
 -145, -144, -140, -138,    0, -137, -134, -147, -143,  -13,
 -136,    0,    0, -124,    0, -123, -177, -122,    0, -120,
 -119,    0, -243,  -99,    0,    0,    0,  -90,    0,    0,
    0,  -88, -152, -152, -152, -189,    0,  -87, -152,    0,
  -86,    0, -152, -152,    0, -152,    0, -121,    0, -186,
    0, -184,    0, -152,  -85, -152, -152,    0,    0, -152,
 -152, -152,  -84,  -83,    0,    0,    0,    0,  -82,  -81,
    0,    0,  -92,    0,  -62,  -62, -154,    0,    0,    0,
    0,  -80,  -79,  -78,   -3,    0,    0,  -77,    0,  -76,
  -75,  -74,  -73,  -72,    0,  -71,  -68,  -70,    0,  -67,
  -66,    0,  -65,  -64,  -61,  -60,  -59,    0,    0,    0,
    0,  -57,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  -56,    0,    0,    0,    0,    0,  -55,    0,  -54,
  -53,  -54,    0,    0,    0,    0,    0,    0,  -52,  -51,
    0,    0,  -50,    0,  -46,  -47,  -45,    0, -152,  -44,
    0,  -43,  -41,    0,  -42,  -39,  -40,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -35,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -34,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -174,
  -33,    0,  -32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -30,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
   40,    0,    0,    0, -112,   19,  -89,  -25,    0, -103,
    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 227
const short yytable[] = {                                     152,
  153,  154,   71,  148,  185,  158,   97,  101,   99,  160,
  161,   42,  162,  147,   43,  183,   96,  107,   95,   44,
  171,  184,  173,  174,  100,   47,  175,  176,  177,   51,
   52,   53,   66,   67,   56,  114,  115,   59,   60,   61,
   62,   45,   65,  120,  116,  117,   46,   72,   73,   74,
   48,   76,   77,  135,   91,  138,   49,  188,   90,  121,
  122,  123,   92,  118,  119,   93,  137,  155,  156,  136,
  164,  165,  168,  169,   50,   54,   55,   57,  192,   58,
   63,  143,   64,   68,   75,   78,   79,   80,   81,  215,
   82,    0,    0,   83,   85,  167,   87,  170,   89,  103,
  104,  105,  106,  109,    0,  113,  107,  110,  124,  125,
  126,  127,  133,  128,    2,  222,  134,  129,  130,  131,
    3,    4,  132,  140,    5,    6,    7,    8,    9,   10,
   11,   12,   13,  141,  142,  144,  145,  146,  163,  166,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,  149,   32,
   33,   34,   35,   36,   37,   38,   39,  150,  182,  151,
  157,  159,  172,  178,  179,  180,  181,  189,  190,  191,
  193,  194,  195,  196,  197,  187,  199,  198,  200,  202,
  201,  203,  204,  205,    0,    0,  206,  207,  208,    0,
  210,  209,  211,    0,  214,    0,  212,  218,  216,  217,
  219,  220,  221,    0,  224,    0,  223,  225,  226,  227,
  228,   83,    0,   55,   66,   71,   84,
};
const short yycheck[] = {                                     103,
  104,  105,   28,   93,   67,  109,   70,   66,   67,  113,
  114,  258,  116,  257,  257,   78,   80,  261,   82,  257,
  124,   84,  126,  127,   83,    7,  130,  131,  132,   11,
   12,   13,  257,  258,   16,  257,  258,   19,   20,   21,
   22,  258,   24,  293,  257,  258,  257,   29,   30,   31,
  257,   33,   34,   67,   65,   69,  257,  147,   69,  309,
  310,  311,   73,  257,  258,   76,   80,  257,  258,   83,
  257,  258,  257,  258,  257,  257,  257,  257,   82,  258,
  257,  259,  258,  258,  258,  257,  257,  257,  257,  202,
  258,   -1,   -1,  260,  260,  121,  261,  123,  258,  257,
  257,  257,  261,  257,   -1,  257,  261,  260,  257,  260,
  257,  257,  260,  258,  256,  219,  260,  258,  257,  257,
  262,  263,  257,  260,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  258,  258,  258,  257,  257,  260,  121,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  258,  301,
  302,  303,  304,  305,  306,  307,  308,  258,  261,  258,
  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  258,  146,  258,  260,  257,  257,
  261,  258,  258,  258,   -1,   -1,  258,  258,  258,   -1,
  257,  259,  258,   -1,  258,   -1,  261,  258,  261,  261,
  257,  259,  258,   -1,  258,   -1,  261,  259,  261,  259,
  261,  257,   -1,  258,  258,  258,  257,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 312
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'A'","'B'","'C'",
0,"'E'","'F'",0,0,"'I'",0,0,"'L'",0,"'N'",0,"'P'",0,"'R'","'S'","'T'",0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,"SP","CRLF","COMMA","STRING","NUMBER","USER","PASS","ACCT","REIN",
"QUIT","PORT","PASV","TYPE","STRU","MODE","RETR","STOR","APPE","MLFL","MAIL",
"MSND","MSOM","MSAM","MRSQ","MRCP","ALLO","REST","RNFR","RNTO","ABOR","DELE",
"CWD","LIST","NLST","SITE","STAT","HELP","NOOP","MKD","RMD","PWD","CDUP","STOU",
"SMNT","SYST","SIZE","MDTM","AUTH","ADAT","PROT","PBSZ","CCC","UMASK","IDLE",
"CHMOD","LEXERR",
};
const char * const yyrule[] = {
"$accept : cmd_list",
"cmd_list :",
"cmd_list : cmd_list cmd",
"cmd_list : cmd_list rcmd",
"cmd : USER SP username CRLF",
"cmd : PASS SP password CRLF",
"cmd : PORT SP host_port CRLF",
"cmd : PASV check_login CRLF",
"cmd : PROT SP prot_code CRLF",
"cmd : CCC CRLF",
"cmd : PBSZ SP STRING CRLF",
"cmd : TYPE SP type_code CRLF",
"cmd : STRU SP struct_code CRLF",
"cmd : MODE SP mode_code CRLF",
"cmd : ALLO SP NUMBER CRLF",
"cmd : ALLO SP NUMBER SP 'R' SP NUMBER CRLF",
"cmd : RETR check_login SP pathname CRLF",
"cmd : STOR check_login SP pathname CRLF",
"cmd : APPE check_login SP pathname CRLF",
"cmd : NLST check_login CRLF",
"cmd : NLST check_login SP STRING CRLF",
"cmd : LIST check_login CRLF",
"cmd : LIST check_login SP pathname CRLF",
"cmd : STAT check_login SP pathname CRLF",
"cmd : STAT CRLF",
"cmd : DELE check_login SP pathname CRLF",
"cmd : RNTO SP pathname CRLF",
"cmd : ABOR CRLF",
"cmd : CWD check_login CRLF",
"cmd : CWD check_login SP pathname CRLF",
"cmd : HELP CRLF",
"cmd : HELP SP STRING CRLF",
"cmd : NOOP CRLF",
"cmd : MKD nonguest SP pathname CRLF",
"cmd : RMD nonguest SP pathname CRLF",
"cmd : PWD check_login CRLF",
"cmd : CDUP check_login CRLF",
"cmd : SITE SP HELP CRLF",
"cmd : SITE SP HELP SP STRING CRLF",
"cmd : SITE SP UMASK check_login CRLF",
"cmd : SITE SP UMASK nonguest SP octal_number CRLF",
"cmd : SITE SP CHMOD nonguest SP octal_number SP pathname CRLF",
"cmd : SITE SP IDLE CRLF",
"cmd : SITE SP IDLE SP NUMBER CRLF",
"cmd : STOU check_login SP pathname CRLF",
"cmd : SYST CRLF",
"cmd : SIZE check_login SP pathname CRLF",
"cmd : MDTM check_login SP pathname CRLF",
"cmd : AUTH SP STRING CRLF",
"cmd : ADAT SP STRING CRLF",
"cmd : QUIT CRLF",
"cmd : error CRLF",
"rcmd : RNFR check_login SP pathname CRLF",
"rcmd : REST SP byte_size CRLF",
"username : STRING",
"password :",
"password : STRING",
"byte_size : NUMBER",
"host_port : NUMBER COMMA NUMBER COMMA NUMBER COMMA NUMBER COMMA NUMBER COMMA NUMBER",
"form_code : 'N'",
"form_code : 'T'",
"form_code : 'C'",
"prot_code : 'C'",
"prot_code : 'S'",
"prot_code : 'P'",
"prot_code : 'E'",
"type_code : 'A'",
"type_code : 'A' SP form_code",
"type_code : 'E'",
"type_code : 'E' SP form_code",
"type_code : 'I'",
"type_code : 'L'",
"type_code : 'L' SP byte_size",
"type_code : 'L' byte_size",
"struct_code : 'F'",
"struct_code : 'R'",
"struct_code : 'P'",
"mode_code : 'S'",
"mode_code : 'B'",
"mode_code : 'C'",
"pathname : pathstring",
"pathstring : STRING",
"octal_number : NUMBER",
"check_login :",
"nonguest : check_login",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 871 "./ftpcmd.y"

struct tab cmdtab[] = {		/* In order defined in RFC 765 */
	{ "USER", USER, STR1, 1,	"<sp> username" },
	{ "PASS", PASS, ZSTR1, 1,	"<sp> password" },
	{ "ACCT", ACCT, STR1, 0,	"(specify account)" },
	{ "SMNT", SMNT, ARGS, 0,	"(structure mount)" },
	{ "REIN", REIN, ARGS, 0,	"(reinitialize server state)" },
	{ "QUIT", QUIT, ARGS, 1,	"(terminate service)", },
	{ "PORT", PORT, ARGS, 1,	"<sp> b0, b1, b2, b3, b4" },
	{ "PASV", PASV, ARGS, 1,	"(set server in passive mode)" },
	{ "TYPE", TYPE, ARGS, 1,	"<sp> [ A | E | I | L ]" },
	{ "STRU", STRU, ARGS, 1,	"(specify file structure)" },
	{ "MODE", MODE, ARGS, 1,	"(specify transfer mode)" },
	{ "RETR", RETR, STR1, 1,	"<sp> file-name" },
	{ "STOR", STOR, STR1, 1,	"<sp> file-name" },
	{ "APPE", APPE, STR1, 1,	"<sp> file-name" },
	{ "MLFL", MLFL, OSTR, 0,	"(mail file)" },
	{ "MAIL", MAIL, OSTR, 0,	"(mail to user)" },
	{ "MSND", MSND, OSTR, 0,	"(mail send to terminal)" },
	{ "MSOM", MSOM, OSTR, 0,	"(mail send to terminal or mailbox)" },
	{ "MSAM", MSAM, OSTR, 0,	"(mail send to terminal and mailbox)" },
	{ "MRSQ", MRSQ, OSTR, 0,	"(mail recipient scheme question)" },
	{ "MRCP", MRCP, STR1, 0,	"(mail recipient)" },
	{ "ALLO", ALLO, ARGS, 1,	"allocate storage (vacuously)" },
	{ "REST", REST, ARGS, 1,	"(restart command)" },
	{ "RNFR", RNFR, STR1, 1,	"<sp> file-name" },
	{ "RNTO", RNTO, STR1, 1,	"<sp> file-name" },
	{ "ABOR", ABOR, ARGS, 1,	"(abort operation)" },
	{ "DELE", DELE, STR1, 1,	"<sp> file-name" },
	{ "CWD",  CWD,  OSTR, 1,	"[ <sp> directory-name ]" },
	{ "XCWD", CWD,	OSTR, 1,	"[ <sp> directory-name ]" },
	{ "LIST", LIST, OSTR, 1,	"[ <sp> path-name ]" },
	{ "NLST", NLST, OSTR, 1,	"[ <sp> path-name ]" },
	{ "SITE", SITE, SITECMD, 1,	"site-cmd [ <sp> arguments ]" },
	{ "SYST", SYST, ARGS, 1,	"(get type of operating system)" },
	{ "STAT", STAT, OSTR, 1,	"[ <sp> path-name ]" },
	{ "HELP", HELP, OSTR, 1,	"[ <sp> <string> ]" },
	{ "NOOP", NOOP, ARGS, 1,	"" },
	{ "MKD",  MKD,  STR1, 1,	"<sp> path-name" },
	{ "XMKD", MKD,  STR1, 1,	"<sp> path-name" },
	{ "RMD",  RMD,  STR1, 1,	"<sp> path-name" },
	{ "XRMD", RMD,  STR1, 1,	"<sp> path-name" },
	{ "PWD",  PWD,  ARGS, 1,	"(return current directory)" },
	{ "XPWD", PWD,  ARGS, 1,	"(return current directory)" },
	{ "CDUP", CDUP, ARGS, 1,	"(change to parent directory)" },
	{ "XCUP", CDUP, ARGS, 1,	"(change to parent directory)" },
	{ "STOU", STOU, STR1, 1,	"<sp> file-name" },
	{ "AUTH", AUTH, STR1, 1,	"<sp> auth-type" },
	{ "ADAT", ADAT, STR1, 1,	"<sp> auth-data" },
	{ "PROT", PROT, ARGS, 1,	"<sp> protection-level" },
	{ "PBSZ", PBSZ, STR1, 1,	"<sp> buffer-size" },
	{ "CCC",  CCC,  ARGS, 1,	"(clear command channel)" },
	{ "SIZE", SIZE, OSTR, 1,	"<sp> path-name" },
	{ "MDTM", MDTM, OSTR, 1,	"<sp> path-name" },
	{ NULL,   0,    0,    0,	0 }
};

struct tab sitetab[] = {
	{ "UMASK", UMASK, ARGS, 1,	"[ <sp> umask ]" },
	{ "IDLE", IDLE, ARGS, 1,	"[ <sp> maximum-idle-time ]" },
	{ "CHMOD", CHMOD, NSTR, 1,	"<sp> mode <sp> file-name" },
	{ "HELP", HELP, OSTR, 1,	"[ <sp> <string> ]" },
	{ NULL,   0,    0,    0,	0 }
};

static struct tab *
lookup(p, cmd)
	register struct tab *p;
	char *cmd;
{

	for (; p->name != NULL; p++)
		if (strcmp(cmd, p->name) == 0)
			return (p);
	return (0);
}

/*
 * urgsafe_getc - hacked up getc to ignore EOF if SIOCATMARK returns TRUE
 */
static int
urgsafe_getc(f)
	FILE *f;
{
	register int c;
	int atmark;

	c = getc(f);
	if (c == EOF) {
		if (ioctl(fileno(f), SIOCATMARK, &atmark) != -1) {
			c = getc(f);
			syslog(LOG_DEBUG, "atmark: c=%d", c);
		}
	}
	return c;
}

#include <arpa/telnet.h>

/*
 * getline - a hacked up version of fgets to ignore TELNET escape codes.
 */
char *
getline(s, n, iop)
	char *s;
	int n;
	register FILE *iop;
{
	register int c;
	register char *cs;

	cs = s;
/* tmpline may contain saved command from urgent mode interruption */
	for (c = 0; tmpline[c] != '\0' && --n > 0; ++c) {
		*cs++ = tmpline[c];
		if (tmpline[c] == '\n') {
			*cs++ = '\0';
			if (debug)
				syslog(LOG_DEBUG, "command: %s", s);
			tmpline[0] = '\0';
			return(s);
		}
		if (c == 0)
			tmpline[0] = '\0';
	}
	while ((c = urgsafe_getc(iop)) != EOF) {
		c &= 0377;
		if (c == IAC) {
			if (debug) syslog(LOG_DEBUG, "got IAC");
		    if ((c = urgsafe_getc(iop)) != EOF) {
			c &= 0377;
			if (debug) syslog(LOG_DEBUG, "got IAC %d", c);
			switch (c) {
			case WILL:
			case WONT:
				c = urgsafe_getc(iop);
				printf("%c%c%c", IAC, DONT, 0377&c);
				(void) fflush(stdout);
				continue;
			case DO:
			case DONT:
				c = urgsafe_getc(iop);
				printf("%c%c%c", IAC, WONT, 0377&c);
				(void) fflush(stdout);
				continue;
			case IAC:
				break;
			default:
				continue;	/* ignore command */
			}
		    }
		}
		*cs++ = c;
		if (--n <= 0 || c == '\n')
			break;
	}
	if (c == EOF && cs == s)
		return (NULL);
	*cs++ = '\0';
	if (auth_type) {
	    char out[sizeof(cbuf)], *cp;
	    int len, mic;


	    /* Check to see if we have a protected command. */
	    if (!((mic = strncmp(s, "ENC", 3)) && strncmp(s, "MIC", 3)
		&& strncmp(s, "AUTH", 4)
#ifndef NOCONFIDENTIAL
	        && strncmp(s, "CONF", 4)
#endif
	        ) && (cs = strpbrk(s, " \r\n"))) {
	    	    *cs++ = '\0'; /* If so, split it into s and cs. */
	    } else { /* If not, check if unprotected commands are allowed. */
		if(ccc_ok) {
		    clevel = PROT_C;
		    upper(s);
		    return(s);
		} else {
		    reply(533, "All commands must be protected.");
		    syslog(LOG_ERR, "Unprotected command received");
		    *s = '\0';
		    return(s);
		}
	    }
	    upper(s);
	    if (debug)
	        syslog(LOG_INFO, "command %s received (mic=%d)", s, mic);
#ifdef NOCONFIDENTIAL
	    if (!strcmp(s, "CONF")) {
		reply(537, "CONF protected commands not supported.");
		*s = '\0';
		return(s);
	    }
#endif
/* Some paranoid sites may want to require that commands be encrypted. */
#ifdef PARANOID
	    if (mic) {
		reply(533, "All commands must be ENC protected.  Retry command under ENC.");
		*s = '\0';
		return(s);
	    }
#endif /* PARANOID */
#ifdef NOENCRYPTION
	    if (!mic) {
		reply(533, "ENC protection not supported.  Retry command under MIC.");
		*s = '\0';
		return(s);
	    }
#endif /* NOENCRYPTION */
	    if ((cp = strpbrk(cs, " \r\n")))
		*cp = '\0';
	    kerror = radix_encode(cs, out, &len, 1);
	    if (kerror) {
		reply(501, "Can't base 64 decode argument to %s command (%s)",
		      mic ? "MIC" : "ENC", radix_error(kerror));
		*s = '\0';
		return(s);
	    }
	    if (debug) syslog(LOG_DEBUG, "getline got %d from %s <%s>\n", 
			      len, cs, mic?"MIC":"ENC");
	    clevel = mic ? PROT_S : PROT_P;
#ifdef KRB5_KRB4_COMPAT
	    if (strcmp(auth_type, "KERBEROS_V4") == 0) {
		if ((kerror = mic ?
		    krb_rd_safe((unsigned char *)out, len, &kdata.session,
			    &his_addr, &ctrl_addr, &msg_data)
		  : krb_rd_priv((unsigned char *)out, len, schedule,
			    &kdata.session, &his_addr, &ctrl_addr, &msg_data))
			!= KSUCCESS) {
		    reply(535, "%s! (%s)",
			   mic ? "MIC command modified" : "ENC command garbled",
			   krb_get_err_text(kerror));
		    syslog(LOG_ERR,"%s failed: %s",
			   mic ? "MIC krb_rd_safe" : "ENC krb_rd_priv",
			   krb_get_err_text(kerror));
		    *s = '\0';
		    return(s);
		}
		(void) memcpy(s, msg_data.app_data, msg_data.app_length);
		(void) strcpy(s+msg_data.app_length, "\r\n");
	    }
#endif /* KRB5_KRB4_COMPAT */
#ifdef GSSAPI
/* we know this is a MIC or ENC already, and out/len already has the bits */
	    if (strcmp(auth_type, "GSSAPI") == 0) {
		gss_buffer_desc xmit_buf, msg_buf;
		OM_uint32 maj_stat, min_stat;
		int conf_state;

		xmit_buf.value = out;
		xmit_buf.length = len;
		/* decrypt the message */
		conf_state = !mic;
		maj_stat = gss_unseal(&min_stat, gcontext, &xmit_buf,
				      &msg_buf, &conf_state, NULL);
		if (maj_stat == GSS_S_CONTINUE_NEEDED) {
			if (debug) syslog(LOG_DEBUG, "%s-unseal continued", 
					  mic?"MIC":"ENC");
			reply(535, "%s-unseal continued, oops",
			      mic?"MIC":"ENC");
			*s = 0; return s;
		}
		if (maj_stat != GSS_S_COMPLETE) {
			reply_gss_error(535, maj_stat, min_stat, 
					mic? "failed unsealing MIC message":
					"failed unsealing ENC message");
			*s = 0;
			return s;
		}

		memcpy(s, msg_buf.value, msg_buf.length);
		strcpy(s+msg_buf.length-(s[msg_buf.length-1]?0:1), "\r\n");
		gss_release_buffer(&min_stat, &msg_buf);
	    }
#endif /* GSSAPI */
	    /* Other auth types go here ... */

	    /* A password should never be MICed, but the CNS ftp
	     * client and the pre-6/98 Krb5 client did this if you
	     * authenticated but didn't encrypt.
	     */
	    if (authlevel && mic && !strncmp(s, "PASS", 4)) {
	    	lreply(530, "There is a problem with your ftp client. Password refused.");
		reply(530, "Enable encryption before logging in, or update your ftp program.");
		*s = 0;
		return s;
	    }

	}
#if defined KRB5_KRB4_COMPAT || defined GSSAPI	/* or other auth types */
	else {	/* !auth_type */
	    if ( (!(strncmp(s, "ENC", 3))) || (!(strncmp(s, "MIC", 3)))
#ifndef NOCONFIDENTIAL
                || (!(strncmp(s, "CONF", 4)))
#endif
                                        ) {
                reply(503, "Must perform authentication before sending protected commands");
                *s = '\0';
                return(s);
	    }
	}
#endif /* KRB5_KRB4_COMPAT || GSSAPI */

	if (debug) {
		if (!strncmp(s, "PASS ", 5) && !guest)
			syslog(LOG_DEBUG, "command: <PASS XXX>");
		else
			syslog(LOG_DEBUG, "command: <%.*s>(%d)",
			       strlen(s) - 2, s, strlen(s));
	}
	return (s);
}

static krb5_sigtype
toolong(sig)
	int sig;
{
	time_t now;

	reply(421,
	  "Timeout (%d seconds): closing control connection.", timeout);
	(void) time(&now);
	if (logging) {
		syslog(LOG_INFO,
			"User %s timed out after %d seconds at %s",
			(pw ? pw -> pw_name : "unknown"), timeout, ctime(&now));
	}
	dologout(1);
}

static int
yylex()
{
	static int cpos, state;
	register char *cp, *cp2;
	register struct tab *p;
	int n;
	char c;

	for (;;) {
		switch (state) {

		case CMD:
			(void) signal(SIGALRM, toolong);
			(void) alarm((unsigned) timeout);
			if (getline(cbuf, sizeof(cbuf)-1, stdin) == NULL) {
				reply(221, "You could at least say goodbye.");
				dologout(0);
			}
			(void) alarm(0);

			/* If getline() finds an error, the string is null */
			if (*cbuf == '\0')
				continue;

#ifdef SETPROCTITLE
			if (strncasecmp(cbuf, "PASS", 4) != NULL)
				setproctitle("%s: %s", proctitle, cbuf);
#endif /* SETPROCTITLE */
			if ((cp = strchr(cbuf, '\r'))) {
				*cp++ = '\n';
				*cp = '\0';
			}
			if ((cp = strpbrk(cbuf, " \n")))
				cpos = cp - cbuf;
			if (cpos == 0)
				cpos = 4;
			c = cbuf[cpos];
			cbuf[cpos] = '\0';
			upper(cbuf);
			p = lookup(cmdtab, cbuf);
			cbuf[cpos] = c;
			if (p != 0) {
				if (p->implemented == 0) {
					nack(p->name);
					longjmp(errcatch,0);
					/* NOTREACHED */
				}
				state = p->state;
				yylval.str = p->name;
				return (p->token);
			}
			break;

		case SITECMD:
			if (cbuf[cpos] == ' ') {
				cpos++;
				return (SP);
			}
			cp = &cbuf[cpos];
			if ((cp2 = strpbrk(cp, " \n")))
				cpos = cp2 - cbuf;
			c = cbuf[cpos];
			cbuf[cpos] = '\0';
			upper(cp);
			p = lookup(sitetab, cp);
			cbuf[cpos] = c;
			if (p != 0) {
				if (p->implemented == 0) {
					state = CMD;
					nack(p->name);
					longjmp(errcatch,0);
					/* NOTREACHED */
				}
				state = p->state;
				yylval.str = p->name;
				return (p->token);
			}
			state = CMD;
			break;

		case OSTR:
			if (cbuf[cpos] == '\n') {
				state = CMD;
				return (CRLF);
			}
			/* FALLTHROUGH */

		case STR1:
		case ZSTR1:
		dostr1:
			if (cbuf[cpos] == ' ') {
				cpos++;
				state = state == OSTR ? STR2 : state+1;
				return (SP);
			}
			break;

		case ZSTR2:
			if (cbuf[cpos] == '\n') {
				state = CMD;
				return (CRLF);
			}
			/* FALLTHROUGH */

		case STR2:
			cp = &cbuf[cpos];
			n = strlen(cp);
			cpos += n - 1;
			/*
			 * Make sure the string is nonempty and \n terminated.
			 */
			if (n > 1 && cbuf[cpos] == '\n') {
				cbuf[cpos] = '\0';
				yylval.str = copy(cp);
				cbuf[cpos] = '\n';
				state = ARGS;
				return (STRING);
			}
			break;

		case NSTR:
			if (cbuf[cpos] == ' ') {
				cpos++;
				return (SP);
			}
			if (isdigit((int) cbuf[cpos])) {
				cp = &cbuf[cpos];
				while (isdigit((int) cbuf[++cpos]))
					;
				c = cbuf[cpos];
				cbuf[cpos] = '\0';
				yylval.num = atoi(cp);
				cbuf[cpos] = c;
				state = STR1;
				return (NUMBER);
			}
			state = STR1;
			goto dostr1;

		case ARGS:
			if (isdigit((int) cbuf[cpos])) {
				cp = &cbuf[cpos];
				while (isdigit((int) cbuf[++cpos]))
					;
				c = cbuf[cpos];
				cbuf[cpos] = '\0';
				yylval.num = atoi(cp);
				cbuf[cpos] = c;
				return (NUMBER);
			}
			switch (cbuf[cpos++]) {

			case '\n':
				state = CMD;
				return (CRLF);

			case ' ':
				return (SP);

			case ',':
				return (COMMA);

			case 'A':
			case 'a':
				return ('A');

			case 'B':
			case 'b':
				return ('B');

			case 'C':
			case 'c':
				return ('C');

			case 'E':
			case 'e':
				return ('E');

			case 'F':
			case 'f':
				return ('F');

			case 'I':
			case 'i':
				return ('I');

			case 'L':
			case 'l':
				return ('L');

			case 'N':
			case 'n':
				return ('N');

			case 'P':
			case 'p':
				return ('P');

			case 'R':
			case 'r':
				return ('R');

			case 'S':
			case 's':
				return ('S');

			case 'T':
			case 't':
				return ('T');

			}
			break;

		default:
			fatal("Unknown state in scanner.");
		}
		yyerror((char *) 0);
		state = CMD;
		longjmp(errcatch,0);
	}
}

void
upper(s)
	register char *s;
{
	while (*s != '\0') {
		if (islower((int) (*s)))
			*s = toupper((int) (*s));
		s++;
	}
}

static char *
copy(s)
	char *s;
{
	char *p;

	p = malloc((unsigned) strlen(s) + 1);
	if (p == NULL)
		fatal("Ran out of memory.");
	(void) strcpy(p, s);
	return (p);
}

void
help(ctab, s)
	struct tab *ctab;
	char *s;
{
	register struct tab *c;
	register int width, NCMDS;
	char str[80];
	char *ftype;

	if (ctab == sitetab)
		ftype = "SITE ";
	else
		ftype = "";
	width = 0, NCMDS = 0;
	for (c = ctab; c->name != NULL; c++) {
		int len = strlen(c->name);

		if (len > width)
			width = len;
		NCMDS++;
	}
	width = (width + 8) &~ 7;
	if (s == 0) {
		register int i, j, w;
		int columns, lines;

		lreply(214, "The following %scommands are recognized %s.",
		    ftype, "(* =>'s unimplemented)");
		columns = 76 / width;
		if (columns == 0)
			columns = 1;
		lines = (NCMDS + columns - 1) / columns;
		for (i = 0; i < lines; i++) {
			strcpy(str, "   ");
			for (j = 0; j < columns; j++) {
				c = ctab + j * lines + i;
				sprintf(&str[strlen(str)], "%s%c", c->name,
					c->implemented ? ' ' : '*');
				if (c + lines >= &ctab[NCMDS])
					break;
				w = strlen(c->name) + 1;
				while (w < width) {
					strcat(str, " ");
					w++;
				}
			}
			reply(0, "%s", str);
		}
		reply(214, "Direct comments to ftp-bugs@%s.", hostname);
		return;
	}
	upper(s);
	c = lookup(ctab, s);
	if (c == (struct tab *)0) {
		reply(502, "Unknown command %s.", s);
		return;
	}
	if (c->implemented)
		reply(214, "Syntax: %s%s %s", ftype, c->name, c->help);
	else
		reply(214, "%s%-*s\t%s; unimplemented.", ftype, width,
		    c->name, c->help);
}

void
sizecmd(filename)
char *filename;
{
	switch (type) {
	case TYPE_L:
	case TYPE_I: {
		struct stat stbuf;
		if (stat(filename, &stbuf) < 0 ||
		    (stbuf.st_mode&S_IFMT) != S_IFREG)
			reply(550, "%s: not a plain file.", filename);
		else
			reply(213, "%lu", (long) stbuf.st_size);
		break;}
	case TYPE_A: {
		FILE *fin;
		register int c;
		register long count;
		struct stat stbuf;
		fin = fopen(filename, "r");
		if (fin == NULL) {
			perror_reply(550, filename);
			return;
		}
		if (fstat(fileno(fin), &stbuf) < 0 ||
		    (stbuf.st_mode&S_IFMT) != S_IFREG) {
			reply(550, "%s: not a plain file.", filename);
			(void) fclose(fin);
			return;
		}

		count = 0;
		while((c=getc(fin)) != EOF) {
			if (c == '\n')	/* will get expanded to \r\n */
				count++;
			count++;
		}
		(void) fclose(fin);

		reply(213, "%ld", count);
		break;}
	default:
		reply(504, "SIZE not implemented for Type %c.", "?AEIL"[type]);
	}
}
#line 1180 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 2:
#line 199 "./ftpcmd.y"
{
			fromname = (char *) 0;
			restart_point = (off_t) 0;
		}
break;
case 4:
#line 207 "./ftpcmd.y"
{
			user((char *) yyvsp[-1].str);
			free((char *) yyvsp[-1].str);
		}
break;
case 5:
#line 212 "./ftpcmd.y"
{
			pass((char *) yyvsp[-1].str);
			free((char *) yyvsp[-1].str);
		}
break;
case 6:
#line 217 "./ftpcmd.y"
{
			/*
			 * Don't allow a port < 1024 if we're not
			 * connecting back to the original source address
			 * This prevents nastier forms of the bounce attack.
			 */
			if (ntohs(host_port.sin_port) < 1024)
				reply(504, "Port number too low");
			else {
				data_dest = host_port;
				usedefault = 0;
				if (pdata >= 0) {
					(void) close(pdata);
					pdata = -1;
				}
				reply(200, "PORT command successful.");
			}
		}
break;
case 7:
#line 236 "./ftpcmd.y"
{
			if (yyvsp[-1].num)
				passive();
		}
break;
case 8:
#line 241 "./ftpcmd.y"
{
		    if (maxbuf)
			setdlevel (yyvsp[-1].num);
		    else
			reply(503, "Must first set PBSZ");
		}
break;
case 9:
#line 248 "./ftpcmd.y"
{
			if (!allow_ccc) {
			    reply(534, "CCC not supported");
			}
			else {
			    if(clevel == PROT_C && !ccc_ok) {
			        reply(533, "CCC command must be integrity protected");
			    } else {
			        reply(200, "CCC command successful.");
				ccc_ok = 1;
			    }
			}
		}
break;
case 10:
#line 262 "./ftpcmd.y"
{
			/* Others may want to do something more fancy here */
			if (!auth_type)
			    reply(503, "Must first perform authentication");
			else if (strlen(yyvsp[-1].str) > 10 ||
				 (strlen(yyvsp[-1].str) == 10 && 
				  strcmp(yyvsp[-1].str,"4294967296") >= 0))
			    reply(501, "Bad value for PBSZ: %s", yyvsp[-1].str);
			else {
			    if (ucbuf) (void) free(ucbuf);
			    actualbuf = (unsigned int) atol(yyvsp[-1].str);
			    /* I attempt what is asked for first, and if that
			       fails, I try dividing by 4 */
			    while ((ucbuf = (unsigned char *)malloc(actualbuf)) == NULL)
				if (actualbuf)
				    lreply(200, "Trying %u", actualbuf >>= 2);
				else {
				    perror_reply(421,
					"Local resource failure: malloc");
				    dologout(1);
				}
			    reply(200, "PBSZ=%u", maxbuf = actualbuf);
			}
		}
break;
case 11:
#line 287 "./ftpcmd.y"
{
			switch (cmd_type) {

			case TYPE_A:
				if (cmd_form == FORM_N) {
					reply(200, "Type set to A.");
					type = cmd_type;
					form = cmd_form;
				} else
					reply(504, "Form must be N.");
				break;

			case TYPE_E:
				reply(504, "Type E not implemented.");
				break;

			case TYPE_I:
				reply(200, "Type set to I.");
				type = cmd_type;
				break;

			case TYPE_L:
#if NBBY == 8
				if (cmd_bytesz == 8) {
					reply(200,
					    "Type set to L (byte size 8).");
					type = cmd_type;
				} else
					reply(504, "Byte size must be 8.");
#else /* NBBY == 8 */
				UNIMPLEMENTED for NBBY != 8
#endif /* NBBY == 8 */
			}
		}
break;
case 12:
#line 322 "./ftpcmd.y"
{
			switch (yyvsp[-1].num) {

			case STRU_F:
				reply(200, "STRU F ok.");
				break;

			default:
				reply(504, "Unimplemented STRU type.");
			}
		}
break;
case 13:
#line 334 "./ftpcmd.y"
{
			switch (yyvsp[-1].num) {

			case MODE_S:
				reply(200, "MODE S ok.");
				break;

			default:
				reply(502, "Unimplemented MODE type.");
			}
		}
break;
case 14:
#line 346 "./ftpcmd.y"
{
			reply(202, "ALLO command ignored.");
		}
break;
case 15:
#line 350 "./ftpcmd.y"
{
			reply(202, "ALLO command ignored.");
		}
break;
case 16:
#line 354 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				retrieve((char *) 0, (char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 17:
#line 361 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				store_file((char *) yyvsp[-1].str, "w", 0);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 18:
#line 368 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				store_file((char *) yyvsp[-1].str, "a", 0);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 19:
#line 375 "./ftpcmd.y"
{
			if (yyvsp[-1].num)
				send_file_list(".");
		}
break;
case 20:
#line 380 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL) 
				send_file_list((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 21:
#line 387 "./ftpcmd.y"
{
			if (yyvsp[-1].num)
				retrieve("/bin/ls -lgA", "");
		}
break;
case 22:
#line 392 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				retrieve("/bin/ls -lgA %s", (char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 23:
#line 399 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				statfilecmd((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 24:
#line 406 "./ftpcmd.y"
{
			statcmd();
		}
break;
case 25:
#line 410 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				delete_file((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 26:
#line 417 "./ftpcmd.y"
{
			if (fromname) {
				renamecmd(fromname, (char *) yyvsp[-1].str);
				free(fromname);
				fromname = (char *) 0;
			} else {
				reply(503, "Bad sequence of commands.");
			}
			free((char *) yyvsp[-1].str);
		}
break;
case 27:
#line 428 "./ftpcmd.y"
{
			reply(225, "ABOR command successful.");
		}
break;
case 28:
#line 432 "./ftpcmd.y"
{
			if (yyvsp[-1].num)
				cwd(pw->pw_dir);
		}
break;
case 29:
#line 437 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				cwd((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 30:
#line 444 "./ftpcmd.y"
{
			help(cmdtab, (char *) 0);
		}
break;
case 31:
#line 448 "./ftpcmd.y"
{
			register char *cp = (char *)yyvsp[-1].str;

			if (strncasecmp(cp, "SITE", 4) == 0) {
				cp = (char *)yyvsp[-1].str + 4;
				if (*cp == ' ')
					cp++;
				if (*cp)
					help(sitetab, cp);
				else
					help(sitetab, (char *) 0);
			} else
				help(cmdtab, (char *) yyvsp[-1].str);
		}
break;
case 32:
#line 463 "./ftpcmd.y"
{
			reply(200, "NOOP command successful.");
		}
break;
case 33:
#line 467 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				makedir((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 34:
#line 474 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				removedir((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 35:
#line 481 "./ftpcmd.y"
{
			if (yyvsp[-1].num)
				pwd();
		}
break;
case 36:
#line 486 "./ftpcmd.y"
{
			if (yyvsp[-1].num)
				cwd("..");
		}
break;
case 37:
#line 491 "./ftpcmd.y"
{
			help(sitetab, (char *) 0);
		}
break;
case 38:
#line 495 "./ftpcmd.y"
{
			help(sitetab, (char *) yyvsp[-1].str);
		}
break;
case 39:
#line 499 "./ftpcmd.y"
{
			int oldmask;

			if (yyvsp[-1].num) {
				oldmask = umask(0);
				(void) umask(oldmask);
				reply(200, "Current UMASK is %03o", oldmask);
			}
		}
break;
case 40:
#line 509 "./ftpcmd.y"
{
			int oldmask;

			if (yyvsp[-3].num) {
				if ((yyvsp[-1].num == -1) || (yyvsp[-1].num > 0777)) {
					reply(501, "Bad UMASK value");
				} else {
					oldmask = umask(yyvsp[-1].num);
					reply(200,
					    "UMASK set to %03o (was %03o)",
					    yyvsp[-1].num, oldmask);
				}
			}
		}
break;
case 41:
#line 524 "./ftpcmd.y"
{
			if (yyvsp[-5].num && (yyvsp[-1].str != NULL)) {
				if (yyvsp[-3].num > 0777)
					reply(501,
				"CHMOD: Mode value must be between 0 and 0777");
				else if (chmod((char *) yyvsp[-1].str, yyvsp[-3].num) < 0)
					perror_reply(550, (char *) yyvsp[-1].str);
				else
					reply(200, "CHMOD command successful.");
			}
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 42:
#line 538 "./ftpcmd.y"
{
			reply(200,
			    "Current IDLE time limit is %d seconds; max %d",
				timeout, maxtimeout);
		}
break;
case 43:
#line 544 "./ftpcmd.y"
{
			if (yyvsp[-1].num < 30 || yyvsp[-1].num > maxtimeout) {
				reply(501,
			"Maximum IDLE time must be between 30 and %d seconds",
				    maxtimeout);
			} else {
				timeout = yyvsp[-1].num;
				(void) alarm((unsigned) timeout);
				reply(200,
				    "Maximum IDLE time set to %d seconds",
				    timeout);
			}
		}
break;
case 44:
#line 558 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				store_file((char *) yyvsp[-1].str, "w", 1);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 45:
#line 565 "./ftpcmd.y"
{
#ifdef unix
#ifdef __svr4__
#undef BSD
#endif
#ifdef BSD
			reply(215, "UNIX Type: L%d Version: BSD-%d",
				NBBY, BSD);
#else /* BSD */
			reply(215, "UNIX Type: L%d", NBBY);
#endif /* BSD */
#else /* unix */
			reply(215, "UNKNOWN Type: L%d", NBBY);
#endif /* unix */
		}
break;
case 46:
#line 589 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL)
				sizecmd((char *) yyvsp[-1].str);
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 47:
#line 606 "./ftpcmd.y"
{
			if (yyvsp[-3].num && yyvsp[-1].str != NULL) {
				struct stat stbuf;
				if (stat(yyvsp[-1].str, &stbuf) < 0)
					perror_reply(550, yyvsp[-1].str);
				else if ((stbuf.st_mode&S_IFMT) != S_IFREG) {
					reply(550, "%s: not a plain file.",
						(char *) yyvsp[-1].str);
				} else {
					register struct tm *t;
					struct tm *gmtime();
					t = gmtime(&stbuf.st_mtime);
					reply(213,
					    "%4d%02d%02d%02d%02d%02d",
					    1900+t->tm_year, t->tm_mon+1, 
					    t->tm_mday, t->tm_hour, 
					    t->tm_min, t->tm_sec);
				}
			}
			if (yyvsp[-1].str != NULL)
				free((char *) yyvsp[-1].str);
		}
break;
case 48:
#line 629 "./ftpcmd.y"
{
			auth((char *) yyvsp[-1].str);
		}
break;
case 49:
#line 633 "./ftpcmd.y"
{
			auth_data((char *) yyvsp[-1].str);
			free((char *) yyvsp[-1].str);
		}
break;
case 50:
#line 638 "./ftpcmd.y"
{
			reply(221, "Goodbye.");
			dologout(0);
		}
break;
case 51:
#line 643 "./ftpcmd.y"
{
			yyerrok;
		}
break;
case 52:
#line 648 "./ftpcmd.y"
{
			restart_point = (off_t) 0;
			if (yyvsp[-3].num && yyvsp[-1].str) {
				fromname = renamefrom((char *) yyvsp[-1].str);
				if (fromname == (char *) 0 && yyvsp[-1].str) {
					free((char *) yyvsp[-1].str);
				}
			}
		}
break;
case 53:
#line 658 "./ftpcmd.y"
{
			fromname = (char *) 0;
			restart_point = yyvsp[-1].num;
			reply(350, "Restarting at %ld. %s", 
			      (long) restart_point,
			      "Send STORE or RETRIEVE to initiate transfer.");
		}
break;
case 55:
#line 671 "./ftpcmd.y"
{
			*(char **)&(yyval.str) = (char *)calloc(1, sizeof(char));
		}
break;
case 58:
#line 682 "./ftpcmd.y"
{
			register char *a, *p;

			a = (char *)&host_port.sin_addr;
			a[0] = yyvsp[-10].num; a[1] = yyvsp[-8].num; a[2] = yyvsp[-6].num; a[3] = yyvsp[-4].num;
			p = (char *)&host_port.sin_port;
			p[0] = yyvsp[-2].num; p[1] = yyvsp[0].num;
			host_port.sin_family = AF_INET;
		}
break;
case 59:
#line 694 "./ftpcmd.y"
{
		yyval.num = FORM_N;
	}
break;
case 60:
#line 698 "./ftpcmd.y"
{
		yyval.num = FORM_T;
	}
break;
case 61:
#line 702 "./ftpcmd.y"
{
		yyval.num = FORM_C;
	}
break;
case 62:
#line 708 "./ftpcmd.y"
{
		yyval.num = PROT_C;
	}
break;
case 63:
#line 712 "./ftpcmd.y"
{
		yyval.num = PROT_S;
	}
break;
case 64:
#line 716 "./ftpcmd.y"
{
		yyval.num = PROT_P;
	}
break;
case 65:
#line 720 "./ftpcmd.y"
{
		yyval.num = PROT_E;
	}
break;
case 66:
#line 726 "./ftpcmd.y"
{
		cmd_type = TYPE_A;
		cmd_form = FORM_N;
	}
break;
case 67:
#line 731 "./ftpcmd.y"
{
		cmd_type = TYPE_A;
		cmd_form = yyvsp[0].num;
	}
break;
case 68:
#line 736 "./ftpcmd.y"
{
		cmd_type = TYPE_E;
		cmd_form = FORM_N;
	}
break;
case 69:
#line 741 "./ftpcmd.y"
{
		cmd_type = TYPE_E;
		cmd_form = yyvsp[0].num;
	}
break;
case 70:
#line 746 "./ftpcmd.y"
{
		cmd_type = TYPE_I;
	}
break;
case 71:
#line 750 "./ftpcmd.y"
{
		cmd_type = TYPE_L;
		cmd_bytesz = NBBY;
	}
break;
case 72:
#line 755 "./ftpcmd.y"
{
		cmd_type = TYPE_L;
		cmd_bytesz = yyvsp[0].num;
	}
break;
case 73:
#line 761 "./ftpcmd.y"
{
		cmd_type = TYPE_L;
		cmd_bytesz = yyvsp[0].num;
	}
break;
case 74:
#line 768 "./ftpcmd.y"
{
		yyval.num = STRU_F;
	}
break;
case 75:
#line 772 "./ftpcmd.y"
{
		yyval.num = STRU_R;
	}
break;
case 76:
#line 776 "./ftpcmd.y"
{
		yyval.num = STRU_P;
	}
break;
case 77:
#line 782 "./ftpcmd.y"
{
		yyval.num = MODE_S;
	}
break;
case 78:
#line 786 "./ftpcmd.y"
{
		yyval.num = MODE_B;
	}
break;
case 79:
#line 790 "./ftpcmd.y"
{
		yyval.num = MODE_C;
	}
break;
case 80:
#line 796 "./ftpcmd.y"
{
		/*
		 * Problem: this production is used for all pathname
		 * processing, but only gives a 550 error reply.
		 * This is a valid reply in some cases but not in others.
		 */
		if (logged_in && yyvsp[0].str && strncmp((char *) yyvsp[0].str, "~", 1) == 0) {
			char **vv;

			vv = ftpglob((char *) yyvsp[0].str);
			yyval.str = (vv != NULL) ? *vv : NULL;
			if (yyval.str == NULL) {
				if (globerr == NULL)
					yyval.str = yyvsp[0].str;
				else {
					reply(550, "%s", globerr);
					free((char *) yyvsp[0].str);
				}
			} else
				free((char *) yyvsp[0].str);
		} else
			yyval.str = yyvsp[0].str;
	}
break;
case 82:
#line 825 "./ftpcmd.y"
{
		register int ret, dec, multby, digit;

		/*
		 * Convert a number that was read as decimal number
		 * to what it would be if it had been read as octal.
		 */
		dec = yyvsp[0].num;
		multby = 1;
		ret = 0;
		while (dec) {
			digit = dec%10;
			if (digit > 7) {
				ret = -1;
				break;
			}
			ret += digit * multby;
			multby *= 8;
			dec /= 10;
		}
		yyval.num = ret;
	}
break;
case 83:
#line 850 "./ftpcmd.y"
{
		if (logged_in)
			yyval.num = 1;
		else {
			reply(530, "Please login with USER and PASS.");
			yyval.num = 0;
		}
	}
break;
case 84:
#line 861 "./ftpcmd.y"
{
		if (guest) {
			reply(550, "Operation prohibited for anonymous users.");
			yyval.num = 0;
		}
		else
			yyval.num = yyvsp[0].num;
	}
break;
#line 2146 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
